#!/bin/sh

if [ "$#" -ne 1 ] ; then
	echo "Usage $0 <executable>" >&2
	exit 2
fi
NAME="$(basename $1)"

cnt_fail=0
cnt_succ=0

printf "" > failure_"$NAME".log
printf "" > success_"$NAME".log

for sa in "" - ; do
for sb in "" - ; do
for sc in "" - ; do
for sd in "" - ; do
	for a in  5  0 ; do
	for b in 11  0 ; do
	for c in  3  0 ; do
	for d in 19  0 ; do
		outp="$(./"$1" $sa$a $sb$b $sc$c $sd$d 2>/dev/null)"
		if [ "$?" -ne 0 ] ; then
			cnt_fail="$((cnt_fail+1))"
			printf '\n\n' >> failure_"$NAME".log
			printf "%s\n" "$outp"  >> failure_"$NAME".log
		else
			cnt_succ="$((cnt_succ+1))"
            printf '\n\n' >> success_"$SNAME".log
            printf "%s\n" "$outp"  >> success_"$NAME".log
		fi
	done ; done ; done ; done
done ; done ; done ; done

printf " %3d SUCCESSES\n" "$cnt_succ"
printf " %3d FAILURES\n"  "$cnt_fail"
printf " %3d total\n" "$((cnt_succ + cnt_fail))"

